unit uexe;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure LoadDll;
  end;
  {types for dynamical load from dll}
  TF_ShowChild = function (App:TApplication;PFormFreeCallBack:Pointer):TForm;stdcall;
  {Set old Applicaton Var in Dll to protect for GPF}
  TF_SetOldApplication=procedure ;stdcall;
  EDLLLoadError = class(Exception);
  procedure FormFreeCallBack;stdcall;
var
  Form1: TForm1;
  ChildForm:TForm;
  ShowChild :TF_ShowChild;
  SetOldApplication:TF_SetOldApplication;
  dlldbhWnd:hwnd=0;
implementation

uses Umain;

{$R *.DFM}
{must be called in dll to recognize if childform is onloaded}
procedure FormFreeCallBack;
begin
  ChildForm:=Nil;
end;
{dynamically load functions from dlldb.dll}
procedure TForm1.LoadDll;
var LastError:DWord;
begin
  if dlldbhWnd= 0 then begin
    dlldbhWnd:=loadLibrary('DLLDB.DLL');
    if dlldbhWnd =0 then begin
      LastError := GetLastError;
      Raise EDLLLoadError.create(IntToStr(LastError) +
                                 ': Unable to load DLLDB.dll');
    end;
    ShowChild:=getProcAddress(dlldbhWnd,'ShowChild');
    if @showChild=Nil then begin
      Raise EDLLLoadError.create(IntToStr(LastError) +
                                 ': Unable to find function ShowChild');
    end;
    SetOldApplication:=getProcAddress(dlldbhWnd,'SetOldApplication');
    if @SetOldApplication=Nil then begin
      Raise EDLLLoadError.create(IntToStr(LastError) +
                                 ': Unable to find function SetOldApplication');
    end;
  end;
end;
procedure TForm1.Button1Click(Sender: TObject);
begin
  loadDll;
  if not assigned(ChildForm) then begin
    ChildForm:=ShowChild(Application,@FormFreeCallBack);
  end;
  ChildForm.Show;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if dlldbhWnd<>0 then begin
    SetOldApplication;
    FreeLibrary (dlldbhWnd);
  end;
end;


end.
